#include <avr/io.h>
#include <avr/delay.h>
#include <avr/interrupt.h>
#include <avr/signal.h>
#include "defs.h"
#define SEND 1
#define RECIVE 2 //ist der ruhe zustand.
#define BUSY 3   // zustand w�hrend des empfangs
//prototypen
unsigned char  getbit(void); 
void setbit(unsigned char);
unsigned char initmaus(void); 
void sendbyte(void);  // sendet das zu sendende byte bit f�r bit an die maus 
void getbyte(void);   // liest die einzelnen bits und fast sie zu einembyte zusammen
void sendmaus(unsigned char );// sendet ein byte zur maus
void updatevalues(void);
unsigned char readbuttons(void);
signed int getdx(void);
signed int getdy(void);

//funktionen u variablen

volatile unsigned char stat,bitc,sbyte,p,rbyte, rdbyte,bytec,err,x;//stat=sendestatus bitc=bitcounter,sbyte= zu sendendes byte,p=parit�t
												   //rbyte = reciving byte, rdbyte = recived byte err = error byte
volatile unsigned char mbyte[4];

//****************************************************************************
unsigned char initmaus(void)
{
cli();
GIMSK = 1<<INT0;    //interrupts aktivieren
MCUCR = (1<<ISC01)|(0<<ISC00);

sendmaus(0xFF);			//reset
	send_char('a');
while(stat == SEND){
	if ( PIND & 32 )
		send_char('v');
	else
		send_char('o');
}
	send_char('b');
while(stat ==RECIVE){}
	send_char('c');
while(stat== BUSY){}
	send_char('d');

sendmaus(0xf6);			// defaultwerte ausw�hlen 
	send_char('e');

while(stat == SEND){}
while(stat ==RECIVE){}
while(stat== BUSY){}	

sendmaus(0xf4);			// protokoll einschalten 

while(stat == SEND){}
while(stat ==RECIVE){}
while(stat== BUSY){}
 bytec=0;

sei();
return (0);
}

//****************************************************************************
unsigned char getbit(void)
{
return (((mausport))&((1<<mauspin)))>>(mauspin);// bitisolieren 
}

//****************************************************************************
void setbit(unsigned char bit)
{
bit=bit&0x01;// nur das erste bit  im parameter beachten 
if(bit==0)
{
mauspull &= (~mauspin);
}
else
{
mauspull |= mauspin;
p++;//parit�t errechnen;
}

}

//****************************************************************************
void sendbyte(void) // sendet die einzelnen bits an die maus
{


		if(bitc<8)		//bits setzen und dann um eine position nach rechts schieben
		{
		setbit(sbyte); 
		sbyte=sbyte/2;
		}
		else
		{
			if(bitc==8) //parit�ts bit setzen 
			{
			 setbit(~p);
			 p=0;
			}
			if(bitc==9)//stopbit setzen
			{
			 setbit(0x01);
			}
			if(bitc==10)//acknowledge abfangen 
			{
			 mausdr &= (~mauspin);
			 if(getbit())
			 {err=1;}
			 else
			 {err=0;}
			 stat = RECIVE;
			 bitc=0xff;
			 sbyte = 0;
			 rbyte=0;
			 
			}
		}

bitc++;
}

//****************************************************************************
void getbyte(void) // liest die einzelnen bits zu sammen und fast sie zu einem byte
{

	if(bitc==0)
	{
	 stat = BUSY;
	}
	else
	{
	 if(bitc<9)
	 {

	  rbyte=rbyte|(getbit()<<(bitc-1));
	 }
	 else
	 {
		  if(bitc==9)
		  {
		   p=getbit();
		   rdbyte=rbyte;
		  
		  }
		  if(bitc==10)
		  {
		   updatevalues();
		   stat = RECIVE;
		   bitc=0xFF;
		   rbyte = 0;
		  }
	 }
	}
	bitc++;
}
void updatevalues(void)
{
	
	mbyte[bytec++]=rdbyte;
	if (bytec==3)
	{
	bytec=0;
	}
}

unsigned char readbuttons(void)
{
return((mbyte[0]&0xF7));
}

signed int getdx(void)
{

signed int v;
unsigned char f;

f=mbyte[0];
f=f>>4;
f=f&0x01;

if(f==0x01)
	 {
	  v=mbyte[1];
	  v=v|0xff00;
	 }
else
	 {
	  v=0x0000;
	  v=v|mbyte[1];
	 }

mbyte[1]=0x00;
mbyte[0]=mbyte[0]&0xEF;
return v;
}

signed int getdy(void)
{

signed int v;
unsigned char f;

f=mbyte[0];
f=f>>5;
f=f&0x01;

if(f==0x01)
	 {
	  v=mbyte[2];
	  v=v|0xff00;
	 }
else
	 {
	  v=0x0000;
	  v=v|mbyte[2];
	 }

mbyte[2]=0x00;
mbyte[0]=mbyte[0]&0x6F;
return v;
}


//****************************************************************************

void sendmaus(unsigned char mausbyte)
{
cli();
bytec=0;
bitc=0;

mausdr |= mauspin;
mausdr |= clkpin;
sbyte=mausbyte;
stat = SEND;
mauspull &= (~clkpin);
mauspull |= mauspin;
delaymy(300);
mauspull &= (~mauspin);
mausport |= clkpin;
mausdr &= (~clkpin);
GIFR |= INTF0;
sei();
}

//****************************************************************************



SIGNAL(SIG_INTERRUPT0)
{

if(stat==SEND)
	{
	 sendbyte();
	}
else
	{

	 getbyte();
	}

}

